# NOTE: Derived from blib/lib/ClearCase/Wrapper/MGi.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package ClearCase::Wrapper::MGi;

#line 275 "blib/lib/ClearCase/Wrapper/MGi.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/MGi/checkout.al)"
sub checkout {
    for (@ARGV[1..$#ARGV]) { $_ = readlink if -l && defined readlink }
    ClearCase::Argv->ipc(1) unless ClearCase::Argv->ctcmd(1);
    my $ct = ClearCase::Argv->new({autochomp=>1});
    return 0 unless checkcs($ct);
    # Duplicate the base Wrapper checkout functionality.
    my @agg = grep /^-(?:dir|rec|all|avo)/, @ARGV;
    die Msg('E', "mutually exclusive flags: @agg") if @agg > 1;
    if (@agg) {
	# Remove the aggregation flag, push the aggregated list of
	# not-checked-out file elements onto argv, and return.
	my %opt;
	GetOptions(\%opt, qw(directory recurse all avobs ok));
	my @added = AutoNotCheckedOut($agg[0], $opt{ok}, 'f', @ARGV);
	push(@ARGV, @added);
    }
    return 0 if grep /^-(bra|ver)/, @ARGV[1..$#ARGV];
    my %opt;
    GetOptions(\%opt, qw(reserved unreserved nmaster out=s ndata ptime
			 nwarn c=s cfile=s cq cqe nc
			 query nquery usehijack));
    if (my @o = grep /^-/, @ARGV) {
	if (!(grep /^--$/, @o)) {
	    warn Msg('E', "Unsupported options: @o");
	    exit(1);
	}
    }
    my @gopts = ();
    push @opts, q(-res) if $opt{reserved};
    push @gopts, q(-unr) if $opt{unreserved};
    push @gopts, q(-nma) if $opt{nmaster};
    push @gopts, q(-out), $opt{out}     if $opt{out};
    push @gopts, q(-nda) if $opt{ndata};
    push @gopts, q(-pti) if $opt{ptime};
    push @gopts, q(-nwa) if $opt{nwarn};
    push @gopts, q(-cfi), $opt{cfile}   if $opt{cfile};
    push @gopts, q(-cq)  if $opt{cq};
    push @gopts, q(-cqe) if $opt{cqe};
    push @gopts, q(-que) if $opt{query};
    push @gopts, q(-nqu) if $opt{nquery};
    push @gopts, q(-use) if $opt{usehijack};
    my @copt = ();
    push @copt, q(-c), $opt{c} if $opt{c};
    push @copt, q(-nc)         if $opt{nc};
    my @args = ();
    if (MSWIN) {
	for (@ARGV[1..$#ARGV]) { push @args, glob($_); }
    } else {
	@args = @ARGV[1..$#ARGV];
    }
    my $rc = 0;
    my %pbrt = ();
    foreach my $e (@args) {
	if ($ct->argv(qw(des -fmt %m), $e)->qx !~ /version$/) {
	    warn Msg('W', "Not a version: $e");
	    next;
	}
	my ($ver, $bt) = ();
	my $sel = $ct->argv('ls', '-d', "$e")->qx;
	if ($sel =~ /^(.*?) +Rule:.*-mkbranch (.*?)\]?$/) {
	    ($ver, $bt) = ($1, $2);
	}
	if ($bt) {
	    my $main = ($ct->argv('lsvtree', $e)->qx)[0];
	    $main =~ s%^[^@]*\@\@[\\/](.*)$%$1%;
	    my $vob = $ct->argv('des', '-s', "vob:$e")->qx;
	    my $re = pbrtype(\%pbrt, $ct, "$bt\@$vob") ?
		qr([\\/]${main}[\\/]$bt[\\/]\d+$) : qr([\\/]$bt[\\/]\d+$);
	    if ($ver =~ m%$re%) {
		$ct->argv('co', @gopts, @copt, $e);
		$rc |= $ct->system;
	    } else {
		my $r = $ct->argv('mkbranch', @copt,
				  '-ver', "/${main}/0", $bt, $e)->system;
		if ($r) {
		    $rc = 1;
		} else {
		    if ($ver !~ m%\@\@[\\/]${main}[\\/]0$%) {
		        $rc |= $ct->argv('merge', '-to', $e, $ver)->system;
		    }
		}
	    }
	} else {
	    $rc |= $ct->argv('co', @gopts, @copt, $e)->system;
	}
    }
    exit $rc;
}

1;
# end of ClearCase::Wrapper::MGi::checkout
