# NOTE: Derived from blib/lib/ClearCase/Wrapper/MGi.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package ClearCase::Wrapper::MGi;

#line 193 "blib/lib/ClearCase/Wrapper/MGi.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/MGi/lsgenealogy.al)"
sub lsgenealogy {
    GetOptions(\%opt, qw(short all obsolete depth=i));
    Assert(@ARGV > 1);	# die with usage msg if untrue
    shift @ARGV;
    my @argv = ();
    for (@ARGV) {
	$_ = readlink if -l && defined readlink;
	push @argv, MSWIN ? glob($_) : $_;
    }
    ClearCase::Argv->ipc(1) unless ClearCase::Argv->ctcmd(1);
    my $ct = ClearCase::Argv->new({autofail=>0,autochomp=>1,stderr=>0});

    while (my $e = shift @argv) {
	my ($ele, $ver, $type, $pred) =
	    split(/\n/,
		  $ct->argv(qw(des -fmt %En\n%En@@%Vn\n%m\n%En@@%PVn),$e)->qx);
	if (!defined($type) or ($type !~ /version$/)) {
	    warn Msg('W', "Not a version: $e");
	    next;
	}
	$ele =~ s%\\%/%g;
	$ver =~ s%\\%/%g;
	$pred =~ s%\\%/%g;
	$ver = $pred if $ver =~ m%/CHECKEDOUT$%;
	my $obsopt = $opt{obsolete}?' -obs':'';
	my $cto = $ct->argv('lsvtree', '-merge', "-all$obsopt", $ele)->qx;
	$cto =~ s%\\%/%g;
	my @vt = split /\n/, $cto;
	my %gen = ();
	my @stack = ();
	foreach my $g (@vt) {
	    if ($g =~ m%^[^ ].*/0$%) {
		next;
	    }
	    if ($g =~ m%^[^ ].*/([^/()]+)$%) {
		my $b = $1;
		next if $b =~ /[^0-9]/;
	    }
	    if ($g =~ m%^(.*) (\(.*\))$%) {
		$g = $1;
		$gen{$g}{labels} = $2;
	    }
	    if ($g =~ /^  -> (.*)$/) {
		my $v = $1;
		my $n = "$ele\@\@$v";
		push @{ $gen{$stack[-1]}{children} }, $n;
		push @{ $gen{$n}{parents} }, $stack[-1];
		next;
	    }
	    if (findpredinstack($g, \@stack)) {
		push @{ $gen{$g}{parents} }, $stack[-1];
		push @{ $gen{$stack[-1]}{children} }, $g;
	    }
	    push @stack, $g;
	}
	setdepths($ver, 0, \%gen);
	my %seen = ();
	printparents($ver, \%gen, \%seen, 0);
    }
    exit 0;
}

# end of ClearCase::Wrapper::MGi::lsgenealogy
1;
